/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { EntityModelVehicle } from '../model';
/**
 * VehicleSearchControllerApi - axios parameter creator
 * @export
 */
export const VehicleSearchControllerApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} [imoNumber] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        executeSearchVehicleGet: async (imoNumber?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/vehicles/search/findByImoNumber`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (imoNumber !== undefined) {
                localVarQueryParameter['imoNumber'] = imoNumber;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * VehicleSearchControllerApi - functional programming interface
 * @export
 */
export const VehicleSearchControllerApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = VehicleSearchControllerApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {string} [imoNumber] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async executeSearchVehicleGet(imoNumber?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelVehicle>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.executeSearchVehicleGet(imoNumber, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * VehicleSearchControllerApi - factory interface
 * @export
 */
export const VehicleSearchControllerApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = VehicleSearchControllerApiFp(configuration)
    return {
        /**
         * 
         * @param {string} [imoNumber] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        executeSearchVehicleGet(imoNumber?: string, options?: any): AxiosPromise<EntityModelVehicle> {
            return localVarFp.executeSearchVehicleGet(imoNumber, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * VehicleSearchControllerApi - interface
 * @export
 * @interface VehicleSearchControllerApi
 */
export interface VehicleSearchControllerApiInterface {
    /**
     * 
     * @param {string} [imoNumber] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleSearchControllerApiInterface
     */
    executeSearchVehicleGet(imoNumber?: string, options?: AxiosRequestConfig): AxiosPromise<EntityModelVehicle>;

}

/**
 * VehicleSearchControllerApi - object-oriented interface
 * @export
 * @class VehicleSearchControllerApi
 * @extends {BaseAPI}
 */
export class VehicleSearchControllerApi extends BaseAPI implements VehicleSearchControllerApiInterface {
    /**
     * 
     * @param {string} [imoNumber] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleSearchControllerApi
     */
    public executeSearchVehicleGet(imoNumber?: string, options?: AxiosRequestConfig) {
        return VehicleSearchControllerApiFp(this.configuration).executeSearchVehicleGet(imoNumber, options).then((request) => request(this.axios, this.basePath));
    }
}
